<a name="OS v3.17: 270d892"></a>
## 270d892ac71358e475fcd11a6aa90f4cc4aabceb (2022-11-08)


### Added

* **scripts:** added a virtual meter mapping function


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.17 initial release
* **packages:** optimizations for ezconfig and power control


<a name="OS v3.16: 41f2153"></a>
## 41f2153a1781b91f3a7d5c0f8703f49d514e8135 (2022-10-25)


### Added

* **powercontrol:** added support for SMA Inverter Manager (pc7082)


### Updated / Bug Fixes

* **ezconfig:** increased TCP channels to 20 for ULTRA, MEGA2-4G and MEGA2
* **powercontrol:** Reactive Power Control added for Huawei SUN2000 Commercial Inverter (pc7035)
* **packages:** fix for Pyranometer package for cumulative values from Global Variables
* **scripts:** optimization to cronmin.cgi for generation of value from Global Variables
* **scripts:** updates to custom HTTP export


<a name="OS v3.16: 4800552"></a>
## 4800552487ca1b9ee0ce9e99d31ba1888adb8037 (2022-09-02)


### Added

* **powercontrol:** added ABB PVS-50/60 TL (pc7013)


<a name="OS v3.16: 82c5e06"></a>
## 82c5e06d9b3dd41ae24747878d51ffbd707382f6 (2022-09-02)


### Added

* **driver:** tested EVVO 80KTL/100KTL/100KTL-HV/255KTL Inverters (dev7022)
* **powercontrol:** tested EVVO 80KTL/100KTL/100KTL-HV/255KTL (pc7022)


<a name="OS v3.16: 9b18b5a"></a>
## 9b18b5a4d3cb48e0552d405babe0d3915617ade1 (2022-09-02)


### Updated / Bug Fixes

* **powercontrol:** fixed issue with phase-level Reactive Power Control
* **ezdisplay:** improvements to scaling and display of SLD
* **packages:** fix for Pyranometer package for cumulative values from Global Variables


<a name="OS v3.16: 63705af"></a>
## 63705afe114cedfc375ee722ddc06a34613429fa (2022-08-30)


### Added

* **driver:** tested ABB/FIMER VSN800 Weather Station (dev5005)


<a name="OS v3.16: 1724079"></a>
## 1724079673610346199faacffa4cb50740df8fac (2022-08-01)


### Updated / Bug Fixes

* **driver:** fixed kWh scaling for Rish EM 1320/30/40 & Master 3430 (dev6340)


<a name="OS v3.16: efada25"></a>
## efada252a7047d7ae408bb215b8ccb2a98715e62 (2022-07-21)


### Updated / Bug Fixes

* **scripts:** fixed issue with Packages installation resulting in a blank page


<a name="OS v3.16: e4a5de6"></a>
## e4a5de68f44035d7a729749ffe6de520a399b143 (2022-07-19)


### Updated / Bug Fixes

* **driver:** reverted variable name for first pyranometer in Sivara WS101/WS200 RS485 Module (dev5001) to maintain backward compatibility


<a name="OS v3.16: 1dd3589"></a>
## 1dd3589a2840c3756ddbabc853d01ca6109f3cdc (2022-07-19)


### Added

* **driver:** added for WattmonMEGA2-4G (dev22)


<a name="OS v3.16: 36638e6"></a>
## 36638e6e09b15e4493917e79a1ec02289a460dfd (2022-07-18)


### Updated / Bug Fixes

* **firwmare-updater:** fixed an bug in firmware manager for WattmonULTRA, WattmonMEGA2-4G and WattmonMEGA2
* **powercontrol:** fixes for SOFAR Solar 20000TL-33000TL (pc7063)


<a name="OS v3.16: f374475"></a>
## f374475e23a19c39226786a7c958f3a6dadc13e7 (2022-07-12)


### Added

* **ftp:** status checking script added in tests folder


### Updated / Bug Fixes

* **scripts:** updates to various device-related scripts to support new hardware
* **scripts:** fix to ip.cgi for USB issue on WattmonMINI3-4G
* **powercontrol:** updated SOFAR Solar 20000TL-33000TL (pc7063)


<a name="OS v3.16: 6a8683b"></a>
## 6a8683b6c9908b84f02c90bb35998502fd19d7d3 (2022-07-06)


### Added

* **inv-error:** added error code look-up tables for Huawei SUN2000 100-125KTL (err7036)


<a name="OS v3.16: 1645d75"></a>
## 1645d75454d649763cd4b74af3ec2d78705342b6 (2022-07-06)


### Added

* **inv-error:** added error code look-up tables for Havells Enviro GTi 80KT-136KT-HV, SOFAR Solar 80-136KTL-HV (err7031, err7065)


<a name="OS v3.16: 4b20b78"></a>
## 4b20b784550ea2a921919038d0ee1564d790c48a (2022-07-06)


### Updated / Bug Fixes

* **inv-error:** corrected error code look-up tables for Growatt MAX (err7030)


<a name="OS v3.16: 21ae79e"></a>
## 21ae79ec28ad17375dea3f07181904ccd04ca600 (2022-07-06)


### Updated / Bug Fixes

* **powercontrol:** Reactive Power Control added for Schneider Conext CL-25 (pc7071)


<a name="OS v3.16: 804f67f"></a>
## 804f67f1318cf0802af7c20b90c93e05fbe5fe06 (2022-07-06)


### Added

* **powercontrol:** added Power-One Micro Systems SGTU-xxx-N (pc7056)


<a name="OS v3.16: cfd429a"></a>
## cfd429a96fe4bb053893d6bbe68c123b629ddf12 (2022-07-06)


### Updated / Bug Fixes

* **powercontrol:** dynamic scale registers added for ABB PVS-100/120 TL (pc7012)


<a name="OS v3.16: 0039cad"></a>
## 0039cad9cc8420461d684589d49da2d7a93f28a0 (2022-07-06)


### Added

* **driver:** added SOFAR Solar 80-136KTL-HV (dev7065)


<a name="OS v3.16: 0fb674c"></a>
## 0fb674c41f377be5982affc27a3a8127ec301dac (2022-07-06)


### Updated / Bug Fixes

* **driver:** kWh corrected and fault registers added for Havells Enviro GTi 80KT-136KT-HV (dev7031)


<a name="OS v3.16: e774ade"></a>
## e774adec66c0c6ceb61bb60f3c1ecadef1f356c2 (2022-07-06)


### Updated / Bug Fixes

* **driver:** added dummy registers for Growatt MAX Inverter (dev7030)


<a name="OS v3.16: 5179efa"></a>
## 5179efa547b4d938eb7e5393cfdd2080e81ba460 (2022-07-06)


### Updated / Bug Fixes

* **driver:** support for a second pyranometer in Sivara WS101/WS200 RS485 Module (dev5001)


<a name="OS v3.16: a193256"></a>
## a193256f5f842469f36bae4c3b43164eec67ee37 (2022-07-06)


### Added

* **driver:** added for WattmonMEGA2 (dev21)


<a name="OS v3.16: 529d130"></a>
## 529d1304084f9daec2066b67ab6765b21636c15a (2022-05-27)


### Added

* **driver:** added Havells Enviro GTi 80KT-136KT-HV (dev7031)
* **driver:** added Sungrow SG250XH-IN (dev7095)


<a name="OS v3.16: 431f3b0"></a>
## 431f3b0d84205e96b35ef1c76a5ab77e2d98f446 (2022-05-27)


### Added

* **powercontrol:** tested and added Havells Enviro GTi 80KT-136KT-HV (pc7031)
* **powercontrol:** tested and added ZTT SI-10KE~SI-30KE (pc7100)


### Updated / Bug Fixes

* **powercontrol:** modifications to Fronius (pc7026)
* **powercontrol:** modifications to SOFAR Solar 80-136KTL-HV (pc7065)


<a name="OS v3.16: 20142f1"></a>
## 20142f1ff2fde66f216d8fc1351abb7b112d5932 (2022-05-25)


### Updated / Bug Fixes

* **driver:** corrected Schneider Conzerv EM6400NG (dev6420)


<a name="OS v3.16: e9edf11"></a>
## e9edf11df789e4e30f4895e46361f8035aa47903 (2022-05-25)


### Updated / Bug Fixes

* **driver:** updated kVARh, kVAh, phase wise VA,VAR and W values for Schneider Conzerv EM6400NG (dev6420)


<a name="OS v3.16: c41199a"></a>
## c41199a74fa492ff607b4f11a084e3e7275a4265 (2022-05-25)


### Added

* **driver:** added Acrel DTSD1352 Energy Meter (dev6352)


<a name="OS v3.16: 01d6292"></a>
## 01d6292c1f30b712989ad64cedecf0812609aaa1 (2022-05-20)


### Updated / Bug Fixes

* **ezconfig:** bug fix for QOS data export
* **powercontrol:** bug fix for TCP failsafe with connection monitoring and fallback percent


<a name="OS v3.16: 20d4943"></a>
## 20d4943f9cc7f7ab87f625a06e1abb73ffc8eb0a (2022-05-17)


### Added

* **package:** custom package for reading data from Studer Xcom-232i


### Updated / Bug Fixes

* **ezconfig:** updated to support Fourth package


<a name="OS v3.16: ff5d79e"></a>
## ff5d79e9eaec7577342db23455200ff78aced493 (2022-05-17)


### Added

* **driver:** added ZTT SI-10KE~SI-30KE Inverters (dev7100)


<a name="OS v3.16: d57a950"></a>
## d57a950977f212a3c1aafaa2976c1e603151d1e2 (2022-05-10)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.16 full release
* **ezconfig:** fixed issues with settings not getting carried across to other menus


<a name="OS v3.16: 2ea077f"></a>
## 2ea077f71370f10ab02ba89e08e2b68041e39c3d (2022-05-05)


### Added

* **driver:** added Solis Ginlong 5G Inverters (dev7089)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.16 initial release
* **ezconfig:** fixed issues with Modbus TCP settings not getting carried across
* **ezconfig:** improved integration with QOS Energy data formatting
* **ezconfig-lite:** updated to match with new device types look-up
* **mqtt:** fixed cross communication for virtual devices


<a name="OS v3.15: ae68584"></a>
## ae685847051f44870bf6683bbc8ffdfbae13317d (2022-04-26)


### Updated / Bug Fixes

* **config:** added support for WattmonMEGA2 (dev21)


<a name="OS v3.15: e936c1a"></a>
## e936c1a23277df79242e80a083f0dca267fd863c (2022-04-21)


### Updated / Bug Fixes

* **ezconfig:** updates to EZConfig to support QOS Energy data format


<a name="OS v3.15: 6700286"></a>
## 6700286611901079b5bade9f02610764b924c8f4 (2022-04-15)


### Added

* **inv-error:** added error code look-up tables for Polycab, Solis Ginlong (err7058, err7088)


### Updated / Bug Fixes

* **driver:** updated Reactive/Apparent Power scaling for Schneider Conzerv EM6400NG (dev6420)
* **driver:** added dummy registers for Huawei SUN2000 100-125KTL (dev7036)
* **driver:** added dummy registers for SolarEdge Inverter (dev7086)


<a name="OS v3.15: 12eb701"></a>
## 12eb7016b0009dc5cb75bd75a82f3f423f464d9b (2022-04-15)


### Added

* **driver:** added Huawei SmartLogger 1000 (dev7134)
* **scripts:** added a dump for string values


### Updated / Bug Fixes

* **ezconfig:** updated to version 20220413 with bug fixes
* **powercontrol:** updated Power Control for ABB PVS-100/120 TL (pc7012)
* **powercontrol:** updated Reactive Power Control for Sungrow SGxxCX (pc7092) and Sungrow SG250HX-IN (pc7095)


<a name="OS v3.15: 843eeea"></a>
## 843eeeae1d66bad99c2efbb0b9ec183f45856a07 (2022-03-14)


### Added

* **powercontrol:** added active power control for Solax Power X3-MAX and X3-MEGA (pc7067)
* **powercontrol:** added active/reactive power control for Sungrow SG250HX-IN (pc7095)


### Updated / Bug Fixes

* **powercontrol:** updated version to 20220311
* **powercontrol:** updated license key to support Active and Reactive Power Control


<a name="OS v3.15: b73b19f"></a>
## b73b19fa899a17f57554c48971bd1c499a93eed7 (2022-03-03)


### Added

* **powercontrol:** added active/reactive power control for Sungrow SG250HX-IN (pc7095)


<a name="OS v3.15: df5ba5b"></a>
## df5ba5beae8322c51d86553c08811805ca7e25dd (2022-03-03)


### Added

* **inv-error:** added error code look-up table for Sungrow SG250HX-IN (pc7095)


<a name="OS v3.15: 8bed68c"></a>
## 8bed68c4ca088de7507c71c4237e0f0d4636aec4 (2022-03-03)


### Added

* **driver:** added model number look-up table for Sungrow SGxxCX (dev7092)


### Updated / Bug Fixes

* **powercontrol:** updated reactive power control for Sungrow SGxxCX (pc7092)
* **powercontrol:** updated power control for Ksolare (pc7047)


<a name="OS v3.15: c490c76"></a>
## c490c76a44edc1e19f99bdf9ce5993f74268c9c0 (2022-02-18)


### Updated / Bug Fixes

* **driver:** converted Sungrow SGxxCX (dev7092) to three register blocks for faster reading


<a name="OS v3.15: 26e5737"></a>
## 26e573728a76d54b0c72100b6986e6df90e0392d (2022-02-18)


### Updated / Bug Fixes

* **driver:** converted Elmeasure Little Genius Plus (dev6540) to a single register block for fast reading


<a name="OS v3.15: 1ddccfa"></a>
## 1ddccfa02c3265af4c74be9eb99d6df04616fd00 (2022-02-17)


### Updated / Bug Fixes

* **powercontrol:** multiple changes to code for reactive power control and removed debug info
* **scripts:** changes for firmware logging


<a name="OS v3.15: 58c1e73"></a>
## 58c1e73391c8372ada2d726ad4b649476eb10c54 (2022-02-12)


### Updated / Bug Fixes

* **driver:** corrected register for Growatt MAX (dev7030)


<a name="OS v3.15: e3d3bf0"></a>
## e3d3bf0df664474ff059bda9a7ad27e17b70c6ca (2022-02-12)


### Updated / Bug Fixes

* **driver:** fixed scaling for ABB PVS-100/120-TL (dev7012)


<a name="OS v3.15: e3d3bf0"></a>
## e3d3bf0df664474ff059bda9a7ad27e17b70c6ca (2022-02-12)


### Updated / Bug Fixes

* **driver:** fixed scaling for ABB PVS-100/120-TL (dev7012)


<a name="OS v3.15: 507bc47"></a>
## 507bc474b3d14c946ef7ad2a66b24b724c08da6a (2022-02-12)


### Added

* **inv-error:** added error code look-up tables for Growatt, SolarEdge, Solis, Sungrow SGxxCX (err7030, err7086, err7089, err7092)


<a name="OS v3.15: 1b116b4"></a>
## 1b116b4f5542b85ec8f00728a22162bdf16abcaf (2022-01-19)


### Updated / Bug Fixes

* **ezconfig:** fixed bug that was causing wrong items to show


<a name="OS v3.15: 648f778"></a>
## 648f778a6b549a66fc739543b08d1cc255aa2cd8 (2022-01-19)


### Updated / Bug Fixes

* **library:** fixed bug in array.inc that was causing wrong items to show in the new EZConfig
* **footer:** updated copyright year to 2022


<a name="OS v3.15: 22bae95"></a>
## 22bae95864f8b880eedd7f04235e20c2fd66f283 (2022-01-13)


### Updated / Bug Fixes

* **firwmare-updater:** fixed an bug in firmware manager


<a name="OS v3.15: 5b8ef77"></a>
## 5b8ef770c83f8bf9c03d95c634ac0840ff579266 (2022-01-13)


### Added

* **powercontrol:** added reactive power control for SolarEdge and Sungrow inverters (pc7086, pc7092, pc7093, pc7094)
* **powercontrol:** added support for Huawei Smartlogger (pc7134)
* **ezdisplay:** interface now shows rated percent vs. active percent vs. potential percent of inverters when power control is enabled


### Updated / Bug Fixes

* **ezconfig:** updated to auto-refresh drivers and added more options for configuration 
* **ftp:** fixed a possible deadlock in data export


<a name="OS v3.15: 1e13bf4"></a>
## 1e13bf48788d294a56dbcd34b75923f1135d27e5 (2021-12-06)


### Updated / Bug Fixes

* **powercontrol:** added intval to calculate percentage value for Ingeteam INGECON SUN 3PLAY 100TL (pc7040)


<a name="OS v3.15: c6e5c75"></a>
## c6e5c75c6608adf04729ff437e0dac9395f40f5c (2021-12-06)


### Updated / Bug Fixes

* **driver:** corrected scaling for DC Power for Huawei SUN2000 Commercial Inverter (dev7035)
* **driver:** corrected scaling for DC Power for Huawei SUN2000 100-125KTL (dev7036)


<a name="OS v3.15: e05a18f"></a>
## e05a18fd9a51699aca74984c4a87d749086d67c2 (2021-12-03)


### Updated / Bug Fixes

* **driver:** corrected scaling for string values and added monthly generation for Sungrow SGxxCX PV String Inverter (dev7092)


<a name="OS v3.15: f8bcb00"></a>
## f8bcb008f2352fbcdf55b66ef1f8e654d42c291c (2021-12-03)


### Updated / Bug Fixes

* **driver:** added string values for SOFAR Solar 50000TL-70000TL (dev7064)


<a name="OS v3.15: 340995b"></a>
## 340995b6112c7f36a9b32cb04f37adbd17559db0 (2021-11-15)


### Added

* **driver:** added L&T WC44xx and WL44xx Series meters (dev6440)


<a name="OS v3.15: 8ff539b"></a>
## 8ff539b1603412bf6cdca15004310f87abd8229e (2021-11-05)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.15 initial release
* **powercontrol:** reworked the interfaces with options for enabled and disabled meters
* **ezconfig:** fixed bug that didn't set the role type properly for Active Power for inverters, which broke the Live PR when not using power control
* **uphp:** reworked the layout of the uPHP settings
* **scripts:** added support for firmware level logging in cronsec, cronmin & uphp
* **scripts:** updated ip.cgi and added a check that prevents connections from wrongly closing unless data is first received, also reworked the push for non-MD5 CSV data
* **data-export:** updated to allow for secure encrypted pushing of data to ems.wattmon.com


<a name="OS v3.14: 312046c"></a>
## 312046c54b9d33c2f27162fd610e899d3f4e5a47 (2021-11-05)


### Added

* **driver:** added support for WattmonULTRA (dev20)


### Updated / Bug Fixes

* **scripts:** bug fixes for memory optimization


<a name="OS v3.14: e94b10e"></a>
## e94b10eba4fe2f38ce25e326ea60fd881239ad92 (2021-10-25)


### Updated / Bug Fixes

* **driver:** updated kWh scaling for ABB PVS-50/60-TL (dev7013)


<a name="OS v3.14: cc76777"></a>
## cc76777b33a88f15cc12f838f5b78d54927a6d4f (2021-10-25)


### Updated / Bug Fixes

* **scripts:** added fix for error exporting seen of ORB's A block



<a name="OS v3.14: d30179a"></a>
## d30179a4f6a4f3de7e088313ac51df4f5085d5c1 (2021-10-15)


### Updated / Bug Fixes

* **driver:** updated Sivara sensors WS200 (dev5000) and (dev5001), PYRA300 (dev5002), and TRH-200 (dev5003) 


<a name="OS v3.14: c18c98f"></a>
## c18c98fa2401a7e379b25b87a25ee71109e83ed5 (2021-10-15)


### Added

* **power-control:** added for SMA Sunny Tripower CORE2 (dev7077)


### Updated / Bug Fixes

* **ezconfigtypes:** updated with all tested drivers for power control


<a name="OS v3.14: 94a2415"></a>
## 94a2415e912eef7c7e56aaf81c60158af8f5cc6d (2021-09-23)


### Added

* **power-control:** added for Solis Ginlong 5G Inverters (dev7089)


<a name="OS v3.14: f711b70"></a>
## f711b70fa4ad497147f45c27ae6dbd65d7853645 (2021-09-23)


### Added

* **driver:** added for Hukseflux SR05-D1A3 Pyranometer (dev5150)


<a name="OS v3.14: b62d698"></a>
## b62d698505a2e55816187ac66b9992967c01014f (2021-09-17)


### Updated / Bug Fixes

* **driver:** updated for Delta M50A-M125HV Commercial Inverters (dev7001)
* **ezconfigtypes:** updated with all recently tested drivers


<a name="OS v3.14: 8c8fa2f"></a>
## 8c8fa2f9abb26171e286bb10927ffd693ed9c914 (2021-09-16)


### Added

* **power-control:** added alternative power control driver for Delta M50A-M125HV (dev7001)


### Updated / Bug Fixes

* **power-control:** fixed bug in EZDisplay when displaying multiple DGs
* **power-control:** corrected write registers for SOFAR Solar 20000TL-33000TL (pc7063) and Evvo 20000TL-33000TL (pc7023)
* **power-control:** corrected write registers for SOFAR Solar 50000TL-70000TL (pc7064)
* **driver:** corrected scaling for Solis Ginlong 4G Inverters (dev7088)


<a name="OS v3.14: 1639030"></a>
## 1639030c84b3f40a8209f44524616cce536ab9a3 (2021-09-06)


### Updated / Bug Fixes

* **power-control:** corrected write register from 16 to 32-bit for SolarEdge (pc7086)


<a name="OS v3.14: bea406e"></a>
## bea406e1e06305107978043cec3a1202b0965e6b (2021-09-02)


### Updated / Bug Fixes

* **driver:** corrected Power scale for Schneider Conext CL-25 (dev7071)


<a name="OS v3.14: fca4fd5"></a>
## fca4fd5af9f9e8377bede92ebd9220b2d52d4c2b (2021-09-02)


### Added

* **driver:** added tested driver for ABB PVS-50/60-TL (dev7013)


<a name="OS v3.14: 520384b"></a>
## 520384bc38f8d6318110e865a5a69dc121b0ac6f (2021-08-27)


### Updated / Bug Fixes

* **driver:** changed Power scale for Schneider Conext CL-25 (dev7071)


<a name="OS v3.14: 17767f1"></a>
## 17767f1343c0cd3931f036af051268f634e22f1a (2021-08-27)


### Updated / Bug Fixes

* **driver:** changed Endian type for Generation for Schneider Conext CL-25 (dev7071)


<a name="OS v3.14: f731ee3"></a>
## f731ee322c109a5f654b0c9e4f1e780f226bf0d4 (2021-08-19)


### Updated / Bug Fixes

* **driver:** changed string scale for Sungrow 110 Scale (dev7094)


<a name="OS v3.14: af58a79"></a>
## af58a7951625db119c420a300ee77cfb1e0419d8 (2021-08-06)


### Updated / Bug Fixes

* **modbus:** fixed issue in Modbus Config for WattmonMINI3-4G


<a name="OS v3.14: 559ea28"></a>
## 559ea28c3c652a0efbf1ef6c83404d743551564a (2021-08-06)


### Updated / Bug Fixes

* **ezconfigtypes:** updated with all tested and newly-created untested drivers


<a name="OS v3.14: a4ade5d"></a>
## a4ade5d646e7cd2b5410c70afc89207603933282 (2021-08-06)


### Added

* **driver:** added tested driver for Eastron SDM120 (dev6125)


### Updated / Bug Fixes

* **driver:** renamed Solis 4G inverter (dev7088) and WattmonULTRA (dev20)


<a name="OS v3.14: 4dbd874"></a>
## 4dbd874148652cfa6ae9621c7d21ca80379b0adf (2021-08-06)


### Added

* **driver:** added tested driver for GoodWe HT Series (dev7025)


<a name="OS v3.14: 1d81a53"></a>
## 1d81a533c0df82c81051bc0805d2d47067ab8de8 (2021-08-06)


### Added

* **driver:** added tested driver for Selec APFC148 (dev6387)


<a name="OS v3.14: 7edc196"></a>
## 7edc196fa76d5b4ced20bb1084bd5ab7e2f4b7d5 (2021-08-05)


### Updated / Bug Fixes

* **powercontrol:** version updated


<a name="OS v3.14: 626b290"></a>
## 626b2909bbf6a72cbc4ffc2653df3970a351547d (2021-08-05)


### Added

* **device:** added WattmonULTRA (dev20)
* **powercontrol:** added Kehua inverter (pc7044)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.14 release
* **devices:** added support for WattmonULTRA hardware
* **powercontrol:** corrected registers for GoodWe HT Series (pc7025)


<a name="OS v3.13: e7d4216"></a>
## e7d42160c5be585793abc7b2cec30860f3f25e72 (2021-07-16)


### Added

* **driver:** added driver for SMA Sunny Tripower CORE2 (dev7077)


<a name="OS v3.13: 2007399"></a>
## 200739937741ff00fc3852ea1d437c04deefaae6 (2021-07-15)


### Updated / Bug Fixes

* **driver:** added persistent registers for EAPL EMS Series energy meters


<a name="OS v3.13: eddd528"></a>
## eddd528f1a178769f5b0d8995785e5f2a6c51464 (2021-07-14)


### Added

* **driver:** added driver for Rish EM 1320/30/40 & Master 3430 (dev6340)


<a name="OS v3.13: 257dcd9"></a>
## 257dcd9a4c45eeb56507d2a636f3258a0c7ced1d (2021-07-14)


### Added

* **driver:** added driver for EAPL EMS Series energy meters (dev6539)


<a name="OS v3.13: 57f6edc"></a>
## 57f6edc0e86fe874c1ee58987c672e601326773e (2021-07-08)


### Updated / Bug Fixes

* **driver:** renamed driver for PYRA-300 with RS485


<a name="OS v3.13: 5b38601"></a>
## 5b38601b0fdd0ea5ce34bdba3dbbfb306e34de36 (2021-07-08)


### Updated / Bug Fixes

* **powercontrol:** fixes for bugs in curtailment values


<a name="OS v3.13: 4fb4f79"></a>
## 4fb4f79a67b69163998e1ec5a2c0b9d3e4ad3e8d (2021-06-29)


### Updated / Bug Fixes

* **driver:** optimized driver for Growatt MAX


<a name="OS v3.13: c80e52f"></a>
## c80e52f9b6b8715282e237aa758d9e1df6c392a6 (2021-06-29)


### Added

* **scripts:** added support for exporting data to PVOutput


### Updated / Bug Fixes

* **powercontrol:** changes to pc7025, pc7030, pc7064, pc7071


<a name="OS v3.13: 960fd08"></a>
## 960fd085f36a250960ee25671df0798d7478a440 (2021-06-03)


### Updated / Bug Fixes

* **packages:** fixes to EZConfig and PC display


<a name="OS v3.13: eabc1be"></a>
## eabc1be (2021-05-12)


### Updated / Bug Fixes

* **packages:** moved DeltaRPI package into legacy_package.tar.gz archive


<a name="OS v3.13: c8bd543"></a>
## c8bd543 (2021-05-11)


### Updated / Bug Fixes

* **packages:** moved unused packages into legacy_package.tar.gz archive
* **ezconfig:** fix for roles issue


<a name="OS v3.13: b5e35b7"></a>
## b5e35b7 (2021-05-10)


### Updated / Bug Fixes

* **ezconfig:** added timeout to execute functions and call the right function based on get parameters
* **ezconfig-lite:** added more options to configuration


<a name="OS v3.13: 6f5b2f1"></a>
## 6f5b2f1 (2021-05-06)


### Updated / Bug Fixes

* **ezconfig:** corrected number of logged roles not being shown
* **CRON:** corrected cronday bug


<a name="OS v3.13: bda38dd"></a>
## bda38dd (2021-05-04)


### Updated / Bug Fixes

* **powercontrol:** updated SOFAR Solar 20000TL-33000TL (pc7063) active power commands
* **powercontrol:** updated SOFAR Solar 50000TL-70000TL (pc7064) active power commands


<a name="OS v3.13: ce0cc93"></a>
## ce0cc93 (2021-04-30)


### Added

* **OTA-updater:** added optional auto-update function for packages
* **firwmare-updater:** added auto-update function for firmwares
* **OS-updater:** added option to include custom repository for proprietary packages
* **package-manager:** added install method option to work with checksum
* **ezconfig:** schedule upload of configuration to Wattmon server for easy restoration
* **driver:** DNP3 Gateway Moxa (dev5015)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.13 initial release
* **device-type:** added support for INT32 Big and Little Endian
* **powercontrol:** corrected binary file issue in PCSec, pc7015 and pc7088
* **driver:** corrected unsigned registers to signed for Canadian Solar GS / GI Inverters (dev7015) & Solis Ginlong 4G / 5G Inverters (dev7088)
* **driver:** corrected scale factor registers for SolarEdge Inverter (dev7086)


<a name="OS v3.12: 54fdf89"></a>
## 54fdf89 (2021-04-16)


### Added

* **checksum:** md5 checksum added to all packages to verify state and auto-repair damaged packages
* **powercontrol:** Goodwe HT Series (pc7025)


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.12 beta release
* **data-export:** added debug option and SSL for custom export
* **ezconfig:** reorganized packages list to include proprietary packages.
* **CRON:** added scheduled disk check operation
* **powercontrol:** corrected binary file issue in PCSec, pc7015 and pc7088


<a name="OS v3.11: 757bd0a"></a>
## 757bd0a (2021-04-07)


### Added

* **roles:** added system integrated functions


### Updated / Bug Fixes

* **ftp:** fixed package issue causing reboots
* **powercontrol:** updated PCsec with diff check


<a name="OS v3.11: e2f678d"></a>
## e2f678d (2021-04-07)


### Added

* **driver:** added WattmonMINI3-4G Data Logger


### Updated / Bug Fixes

* **driver:** tested and scaled Schneider PowerLogic iEM3150
* **driver:** renamed Wattmon Data Logger drivers


<a name="OS v3.11: 9cf2bce"></a>
## 9cf2bce (2021-04-07)


### Added

* **powercontrol:** added Debugging script


### Updated / Bug Fixes

* **powercontrol:** Updated the display issue for negative percentages
* **OS-updater:** renamed incremental package updates to Additional Packages


<a name="OS v3.11: 3f18b39 & c1a3387"></a>
## 3f18b39 & c1a3387 (2021-03-23)


### Added

* **ezconfig:** added EZconfig-lite, a lighter variant of EZconfig that may be run by the Guest user
* **powercontrol:** added a ramp mode check, which verifies if the inverter output is within 20% of the set point applied by the Wattmon


### Updated / Bug Fixes

* **data-export:** added Static Headers and rearranged layout
* **ezconfig:** added compatibility for EZconfig-lite
* **user:** added option in User Settings to enable or disable EZconfig-lite
* **devices-widget:** updated to show PF and phase currents


<a name="OS v3.11: bf45d49"></a>
## bf45d49 (2021-03-17)


### Added

* **driver:** Studer Xcom-485i Communication Module (dev8002)
* **driver:** Studer VarioTrack MPPT Solar Charge Controller (dev5485)


<a name="OS v3.11: 3438e7c"></a>
## 3438e7c (2021-03-17)


### Updated / Bug Fixes

* **powercontrol:** updated Sungrow CX/HX (pc7092) active power check


<a name="OS v3.11: bff56fd"></a>
## bff56fd (2021-03-11)


### Added

* **driver-scaling:** added Dynamic Scaling to Roles


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.11 release
* **powercontrol:** Fixed a bug in phase-wise power control that was not properly detecting the roles
* **powercontrol:** Removed SolarEdge special scaling as it is now in the driver
* **driver-scaling:** Updated SolarEdge (dev7086) to include the dynamic scaling


<a name="OS v3.11: c16367e"></a>
## c16367e (2021-03-11)


### Added

* **driver:** Janitza UMG 103 Power Analyser (dev6103)
* **driver:** Secure Elite 100-103 (dev6110)
* **driver:** Secure Elite 300-303 / 300-307 (dev6310)
* **driver:** Janitza UMG 604 Power Analyser (dev6604)


### Updated / Bug Fixes

* **driver-scaling:** Delta RPI M66H-M88H Commercial Inverter (dev7001)
* **driver-scaling:** Delta RPI M6A-M50A Commercial Inverter (dev7002)
* **driver-naming:** Pyranometer (Virtual)
* **powercontrol:** reformatted MINI Power Control code and added support for many more inverters with option to switch off Thea inverter below 10%


<a name="OS v3.11: 6d9509f"></a>
## 6d9509f (2021-03-10)


### Added

* **scripts:** script to write 32-bit registers on Modbus
* **scripts:** script to write Float Little Endian registers on Modbus


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.11 pre-release
* **driver-registers:** SMA Solid-Q 50 (dev7078)
* **driver-registers:** SolarEdge (dev7086)
* **data-export:** separated topic, header and message content to improve receipt of MQTT data packets
* **email-report:** added daily generation report format


<a name="OS v3.10: 2922042"></a>
## 2922042 (2021-02-23)


### Added

* **email-report:** local Email Reports generation tool
* **data-package:** Flat File DB
* **powercontrol:** KACO new energy Tx1 and Tx3 Series (pc7042)


### Updated / Bug Fixes

* **powercontrol:** included check for DI variations
* **powercontrol:** updated Sungrow 100 (pc7093) and 110 Scale (pc7094) active power check
* **data-export:** improved MQTT communication with multiple devices in various locations
* **data-export:** improvements to custom server data export


<a name="OS v3.10: f1ca89a"></a>
# f1ca89a (2020-12-18)


### Updated / Bug Fixes

* **powercontrol:** Latest additions in power control


<a name="OS v3.10: 307b288"></a>
# 307b288 (2020-11-26)


### Updated / Bug Fixes

* **powercontrol:** bug fix for power meters in power control


<a name="OS v3.10: 8cdcb8d"></a>
## 8cdcb8d (2020-11-26)


### Updated / Bug Fixes

* **firmware-updater:** fixed update issue for OS 3.10


<a name="OS v3.10: 9eb0a05"></a>
## 9eb0a05 (2020-11-25)


### Added

* **modbus-test:** added polling test for Function Code 16


### Updated / Bug Fixes

* **modbus-test:** fixed Modbus tester issue with Baud Rate and Parity not changing


<a name="OS v3.10: 366666f"></a>
# 366666f (2020-11-25)


### Updated / Bug Fixes

* **powercontrol:** updated power control for OS 3.10


<a name="OS v3.10: 742b923"></a>
## 742b923 (2020-11-25)


### Added

* **data-export:** Simple Network Management Protocol (SNMP)
* **usb-driver:** Quectel EC-21 (2C7C125)
* **time:** added support for Time Server sync over TCP


### Updated / Bug Fixes

* **OS-version:** WattmonOS v3.10 released
* **powercontrol:** Huawei SUN2000 Commercial Inverter (pc7035)
* **modbus:** WattmonM2 RS485 Channels correctly recognized
* **ezconfigtypes:** added new line for meter types
* **logs:** updated to display logs for mqtt, network, ftp and modbus


<a name="OS v3.9: 9a38dda"></a>
# 9a38dda (2020-11-05)


### Updated / Bug Fixes

* **powercontrol:** Havells 50000TL-70000TL (pc7033)
* **powercontrol:** SOFAR Solar 50000TL-70000TL (pc7064)


<a name="OS v3.9: d4533b0"></a>
# d4533b0 (2020-10-30)


### Added

* **driver:** Chint Electric CPS50KTL / CPS60KTL (dev7017)
* **powercontrol:** Chint Electric CPS50KTL / CPS60KTL (pc7017)


<a name="OS v3.9: 97e04e4"></a>
## 97e04e4 (2020-10-30)


### Added

* **driver:** KoCoS ME27.1 for Elster A1140/A1700 (dev6271)
* **driver:** Legrand PMX6000 and PMX7300 (dev6730)


### Updated / Bug Fixes

* **driver-registers:** Kipp and Zonen RT1 (dev5122)
* **driver-scaling:** Delta RPI M6A-M50A Commercial Inverter (dev7002)
* **driver-registers:** Thea Inverter (dev7096)
* **driver-naming:** Consul Neowatt Sunbird 3000 (dev7250)
* **ezconfigtypes:** added new inverter and meter types


<a name="OS v3.9: cce54f4"></a>
## cce54f4 (2020-10-30)


### Added

* **data-export:** integration of Simple Network Management Protocol (SNMP)
* **driver:** Wattmon A10 10-Channel ADC Module (Capture Mode) v2 (dev1556)
* **powercontrol:** percent-wise control to prevent inverter ramping up to 100%


### Updated / Bug Fixes

* **driver-registers:** Schneider PowerLogic EM7280 (dev6728)
* **powercontrol:** ABB Pro-33.0-TL (pc7007)


<a name="OS v3.9: 12db687"></a>
## 12db687 (2020-10-15)


### Added

* **driver:** Accuenergy AcuRev 1300 Series (dev6130)
* **driver:** Canadian Solar GS / GI Inverters (dev7015)
* **driver:** Luminous NXi Inverter (dev7049)
* **driver:** Power-One Micro Systems SGTU1-60K Inverter (dev7057)
* **powercontrol:** Canadian Solar GS / GI Inverters (pc7015)
* **powercontrol:** Luminous NXi Inverter (pc7049)
* **powercontrol:** Power-One Micro Systems SGTU1-60K Inverter (pc7057)


### Updated / Bug Fixes

* **driver-naming:** Kstar KSG1-60K Inverter (dev7048)
* **driver-registers:** Solis Ginlong 4G / 5G Inverters (dev7088), added string current
* **ezconfigtypes:** added new inverter and meter types


<a name="OS v3.9: 72e707b"></a>
## 72e707b (2020-10-13)


### Updated

* **OS-version:** WattmonOS v3.9 released


<a name="OS v3.8: d091808"></a>
## d091808 (2020-10-13)


### Added

* **powercontrol:** Havells 50000TL-70000TL (pc7033)


### Updated

* **ezconfigtypes:** added new inverter and meter types


<a name="OS v3.8: 4d49cf2"></a>
## 4d49cf2 (2020-10-13)


### Updated / Bug Fixes

* **powercontrol:** changed Check Meter settings so for a Priority 0 and PF 0, it will not be used in the control algorithm, allowing multiple Check Meters to be used on a site without affecting the control loop


## 2bc71bef30136e52cedc09b9df1d015a15fe53dd - last commit (2023-09-28) -3.18.20230928

